//+------------------------------------------------------------------+
//|                                                      EA try.mq4 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//--- input parameters

extern double    Pipstep=300.0;
extern double    takeprofit=30.0;
extern double    Slip=5;
extern int       buymagic=505050;
extern int       sellmagic=606060;
double AverageBUYprice;
double AverageSELLprice;



//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {                  //Check if there is open long or short position available with magic number. 
                     //if not available, then place orders.
//----
   int i,cnt1=0,cnt2=0; //cnt1=store number of long postions, cnt2=store number of short postions
   int Ticket;
   for(i=1;i<=OrdersTotal();i++)
   {
      if(OrderSelect(i-1,SELECT_BY_POS,MODE_TRADES)==true){
      if((OrderType()==OP_BUY)&&(OrderMagicNumber()==buymagic))
         cnt1++; //Long postion found
      else if((OrderType()==OP_SELL)&&(OrderMagicNumber()==sellmagic))
         cnt2++; //Short position found}
    }}
    
    if(cnt1<1)//No long position found, so place a buy Order
    { RefreshRates();
      Ticket=OrderSend(Symbol(),OP_BUY,0.1,Ask,Slip,0,Ask+Point*takeprofit,"BUY 0",buymagic,0,Green);
      if(Ticket<1)
      Print("Order send fail error #",GetLastError());
      OrderSelect(Ticket,SELECT_BY_TICKET);
      AverageBUYprice=OrderOpenPrice();
    }
    
    if(cnt2<1)//No short position found, so place a sell Order
    { RefreshRates();
      Ticket=OrderSend(Symbol(),OP_SELL,0.1,Bid,Slip,0,Bid-Point*takeprofit,"Sell 0",sellmagic,0,Red);
      if(Ticket<1)
      Print("Order send fail error #",GetLastError());
      OrderSelect(Ticket,SELECT_BY_TICKET);
      AverageSELLprice=OrderOpenPrice();
    }
    
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   double buy_order_lots=0,sell_order_lots=0,BuyLotprice=0,SellLotprice=0,BUY_L=0,SELL_L=0,tp=0;
   double last_buy_price=0,last_sell_price=0;
   double NewAverageBUYprice, NewAverageSELLprice,price;
   int i,cnt1=0,cnt2=0,Ticket,buy,sell;
   int buytickets[],selltickets[],ticket;
   bool result;
   for(i=1;i<=OrdersTotal();i++)                                                        //+---------------FIND LAST ORDER PRICE-----+
   {                                                                                   //|
      if(OrderSelect(i-1,SELECT_BY_POS,MODE_TRADES)==true){                                        //|-------------------------
      if((OrderType()==OP_BUY)&&(OrderMagicNumber()==buymagic))                          //|
         {                                                                             //|
      //      BUY_L=OrderLots();                                                             //|    
      //      buy_order_lots+=BUY_L;                                                             //|      
      //      BuyLotprice+=BUY_L*OrderOpenPrice();                                              //|          Last buy price
      //      AverageBUYprice=NormalizeDouble((BuyLotprice/buy_order_lots),Digits);
            last_buy_price=OrderOpenPrice();                                           //|
            cnt1++;                                                                    //|
         }                                                                             //|------------------------------
      if((OrderType()==OP_SELL)&&(OrderMagicNumber()==sellmagic))                    //|
         {                                                                             //|
       //     SELL_L=OrderLots();                                                             //|           Last sell price
       //     sell_order_lots+=SELL_L;                                                             //|
       //     SellLotprice+=SELL_L*OrderOpenPrice();                                              //|   
       //     AverageSELLprice=NormalizeDouble((SellLotprice/sell_order_lots),Digits);
            last_sell_price=OrderOpenPrice();                                          //|
            cnt2++;                                                                    //|
         }  }                                                                           //|
    }                                                                                  //+-------------------------
    if(cnt1<1){while(!IsTradeAllowed()) Sleep(100);Ticket=OrderSend(Symbol(),OP_BUY,0.1,Ask,Slip,0,Ask+takeprofit*Point,"BUY 0",buymagic,0,Green);}
    if(cnt2<1){while(!IsTradeAllowed()) Sleep(100);Ticket=OrderSend(Symbol(),OP_SELL,0.1,Bid,Slip,0,Bid-takeprofit*Point,"SELL 0",sellmagic,0,Red);}
//+----------- check threshold and place buy order and find new average buy 
    if(last_buy_price>(NormalizeDouble((Ask+Point*Pipstep),Digits)))
      {Print("total buy order is ",cnt1);
      switch(cnt1)
      {
      case 1: RefreshRates();while(!IsTradeAllowed()) Sleep(100);Ticket=OrderSend(Symbol(),OP_BUY,0.10,Ask,Slip,0,0,"BUY 1",buymagic,0,Green);
      if(Ticket<1)Print("Order send fail error #",GetLastError());break;
      case 2: RefreshRates();while(!IsTradeAllowed()) Sleep(100);Ticket=OrderSend(Symbol(),OP_BUY,0.20,Ask,Slip,0,0,"BUY 2",buymagic,0,Green);
      if(Ticket<1)Print("Order send fail error #",GetLastError());break;
      case 3: RefreshRates();while(!IsTradeAllowed()) Sleep(100);Ticket=OrderSend(Symbol(),OP_BUY,0.40,Ask,Slip,0,0,"BUY 3",buymagic,0,Green);
      if(Ticket<1)Print("Order send fail error #",GetLastError());break;
      case 4: RefreshRates();while(!IsTradeAllowed()) Sleep(100);Ticket=OrderSend(Symbol(),OP_BUY,1.00,Ask,Slip,0,0,"BUY 4",buymagic,0,Green);
      if(Ticket<1)Print("Order send fail error #",GetLastError());break;
      case 5: RefreshRates();while(!IsTradeAllowed()) Sleep(100);Ticket=OrderSend(Symbol(),OP_BUY,4.00,Ask,Slip,0,0,"BUY 5",buymagic,0,Green);
      if(Ticket<1)Print("Order send fail error #",GetLastError());break;
      case 6: RefreshRates();while(!IsTradeAllowed()) Sleep(100);Ticket=OrderSend(Symbol(),OP_BUY,10.00,Ask,Slip,0,0,"BUY 6",buymagic,0,Green);
      if(Ticket<1)Print("Order send fail error #",GetLastError());break;
      }
      //+------------------------------------+
      //| recalculate the average buy price  |
      //+------------------------------------+   
      cnt1=0; // new buy order is executed so release the number of buy orders to calculate again 
      for(i=1;i<=OrdersTotal();i++)
         {
         if(OrderSelect(i-1,SELECT_BY_POS,MODE_TRADES)==true){
            if((OrderType()==OP_BUY)&&(OrderMagicNumber()==buymagic))
               {
               BUY_L=OrderLots();
               BuyLotprice+=(BUY_L*OrderOpenPrice());
               buy_order_lots+=BUY_L;
               cnt1++;   //get the latest number of buy orders
               }
            }
         }
         NewAverageBUYprice=BuyLotprice/buy_order_lots;
         tp=NormalizeDouble(NewAverageBUYprice+takeprofit*Point,Digits);
         
         //+------------------------------------+
         //| set new take profit levels         |
         //+------------------------------------+   
         for(i=1;i<=OrdersTotal();i++)
            {
               if(OrderSelect(i-1,SELECT_BY_POS,MODE_TRADES)==true){
                  if((OrderType()==OP_BUY)&&(OrderMagicNumber()==buymagic))
                  {
                     RefreshRates();
                     while(!IsTradeAllowed()) Sleep(100);
                     result=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),tp,0);
                     
                     if(result==false)Print("Buy Modify error is  ",GetLastError()+
                        ". Open price "+DoubleToStr(OrderOpenPrice(), Digits)+
                        ". tp "+DoubleToStr(tp, Digits));      
                  }
               }  
            }
      }
//+----------- check threshold and place sell order and find new average sell price
    if(last_sell_price<(NormalizeDouble((Bid-Point*Pipstep),Digits)))
      {Print("total sell order is ",cnt2);
         switch(cnt2)
            {
            case 1: RefreshRates();while(!IsTradeAllowed()) Sleep(100);Ticket=OrderSend(Symbol(),OP_SELL,0.10,Bid,Slip,0,0,"Sell 1",sellmagic,0,Red);
            if(Ticket<1)Print("Order send fail error #",GetLastError());break;
            case 2: RefreshRates();while(!IsTradeAllowed()) Sleep(100);Ticket=OrderSend(Symbol(),OP_SELL,0.20,Bid,Slip,0,0,"Sell 2",sellmagic,0,Red);
            if(Ticket<1)Print("Order send fail error #",GetLastError());break;
            case 3: RefreshRates();while(!IsTradeAllowed()) Sleep(100);Ticket=OrderSend(Symbol(),OP_SELL,0.40,Bid,Slip,0,0,"Sell 3",sellmagic,0,Red);
            if(Ticket<1)Print("Order send fail error #",GetLastError());break;
            case 4: RefreshRates();while(!IsTradeAllowed()) Sleep(100);Ticket=OrderSend(Symbol(),OP_SELL,1.00,Bid,Slip,0,0,"Sell 4",sellmagic,0,Red);
            if(Ticket<1)Print("Order send fail error #",GetLastError());break;
            case 5: RefreshRates();while(!IsTradeAllowed()) Sleep(100);Ticket=OrderSend(Symbol(),OP_SELL,4.00,Bid,Slip,0,0,"Sell 5",sellmagic,0,Red);
            if(Ticket<1)Print("Order send fail error #",GetLastError());break;
            case 6: RefreshRates();while(!IsTradeAllowed()) Sleep(100);Ticket=OrderSend(Symbol(),OP_SELL,10.00,Bid,Slip,0,0,"Sell 6",sellmagic,0,Red);
            if(Ticket<1)Print("Order send fail error #",GetLastError());break;
            }
         //+------------------------------------+
         //| recalculate the average sell price  |
         //+------------------------------------+   
         cnt2=0; // new sell order is placed so release the number of sell orders to calculate again 
         for(i=1;i<=OrdersTotal();i++)
            {
            if(OrderSelect(i-1,SELECT_BY_POS,MODE_TRADES)==true){
               if((OrderType()==OP_SELL)&&(OrderMagicNumber()==sellmagic))
                  {
                  SELL_L=OrderLots();
                  SellLotprice+=(SELL_L*OrderOpenPrice());
                  sell_order_lots+=SELL_L;
                  cnt2++;   //get the latest number of sell orders
                  }
         
               }
            }
         NewAverageSELLprice=SellLotprice/sell_order_lots;
         tp=NormalizeDouble(NewAverageSELLprice-takeprofit*Point,Digits);
         //+------------------------------------+
         //| set new take profit levels         |
         //+------------------------------------+   
      
         for(i=1;i<=OrdersTotal();i++)
            {
               if(OrderSelect(i-1,SELECT_BY_POS,MODE_TRADES)==true){
               if((OrderType()==OP_SELL)&&(OrderMagicNumber()==sellmagic))
                  {
                     RefreshRates();
                     while(!IsTradeAllowed()) Sleep(100);
                     result=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),tp,0);
                     if(result==false)Print("Sell Modify error is  ",GetLastError()+
                        ". Open price "+DoubleToStr(OrderOpenPrice(), Digits)+
                        ". tp "+DoubleToStr(tp, Digits));  
                  }
            }   }   
      }                  
//----

   return(0);
  }
//+------------------------------------------------------------------+